* FDPROC.PRG
* Procedure File for FoxDraw Graphics Methods Demo
* Defines: ToolBar 'fdToolBar'
* Procs  : Hide & Show ToolBars, FdMainErr

* Toolbar Object captions and tooltips
#INCLUDE "foxdraw.h"

* FDMAIN Class definitions & procedures

* FDToolBar Class Def
DEFINE CLASS fdToolBar  AS ToolBar

ADD OBJECT lbl1		AS LABEL WITH ;
	Caption = LBL1CAP_LOC, ;
	WIDTH = 20,;
	BackColor = RGB(192,192,192)

* Following object Caption changes when clicked
ADD OBJECT cmdDraw	AS commandbutton WITH ;
	HEIGHT = 1.75,;
	WIDTH = 18, ;
	Caption = CMDDRAWCAP2_LOC, ;
	ToolTipText = ;
	"Click to toggle Form Drawing on/off.."

ADD OBJECT lbl2		AS LABEL WITH ;
	Caption = LBL2CAP_LOC, ;
	WIDTH = 18, ;
	BackColor = RGB(192, 192, 192)

* Following object Caption changes when clicked
ADD OBJECT cmdDrawMode	AS commandbutton WITH ;
	HEIGHT = 1.75,;
	WIDTH = 18, ;
	Caption = CMDDRAWMODECAP1_LOC, ;
	ToolTipText = CMDDRAWMODETIP_LOC

ADD OBJECT sepD2	    AS SEPARATOR

ADD OBJECT lbl3 	AS LABEL WITH ;
	Caption = LBL3CAP_LOC, ;
	WIDTH = 18,;
	BackColor = RGB(192, 192, 192)

ADD OBJECT spnPenWidth AS SPINNER WITH ;
	VALUE = 1, ;
	SpinnerLowValue = 1, ;
	SpinnerHighValue = 99, ;
	WIDTH = 12, ;
	Height = 1.75,;
	ToolTipText = SPNPENWIDTHTIP_LOC

ADD OBJECT sepS		AS SEPARATOR

ADD OBJECT lbl4 	AS LABEL WITH ;
	Caption = LBL4CAP_LOC,;
	WIDTH = 18,;
	BackColor = RGB(192, 192, 192)

ADD OBJECT cboPenMode	AS combobox WITH ;
	VALUE = 13, ;
	STYLE = 2, ;
	WIDTH = 20, ;
	ToolTipText = CBOPENMODETIP_LOC

ADD OBJECT sepC1	AS SEPARATOR

ADD OBJECT cmdRed	AS commandbutton WITH ;
	HEIGHT = 1.75, ;
	WIDTH = 18, ;
	Caption = CMDREDCAP_LOC, ;
	ForeColor = RGB(255,0,0), ;
	ToolTipText = CMDREDTIP_LOC

ADD OBJECT cmdGreen	AS commandbutton WITH ;
	HEIGHT = 1.75, ;
	WIDTH = 18, ;
	Caption = CMDGREENCAP_LOC, ;
	ForeColor = RGB(0,255,0), ;
	ToolTipText = CMDGREENTIP_LOC

ADD OBJECT cmdBlue  AS commandbutton WITH ;
	HEIGHT = 1.75,;
	WIDTH = 18,;
	Caption = CMDBLUECAP_LOC, ;
	ForeColor = RGB(0,0,255),;
	ToolTipText = CMDBLUETIP_LOC

ADD OBJECT cmdCustom	AS commandbutton WITH;
	HEIGHT = 1.75, ;
	WIDTH = 18, ;
	Caption = CMDCUSTOMCAP_LOC, ;
	ForeColor = 16711935, ;
	ToolTipText = CMDCUSTOMTIP_LOC

ADD OBJECT cmdErase	AS commandbutton WITH ;
	HEIGHT = 1.75, ;
	WIDTH = 18, ;
	Caption = CMDERASECAP_LOC, ;
	ForeColor = RGB(255,255,255), ;
	ToolTipText = CMDERASETIP_LOC

ADD OBJECT cmdClear	AS commandbutton WITH ;
	HEIGHT = 1.75,;
	WIDTH = 18, ;
	Caption = CMDCLEARCAP_LOC, ;
	ToolTipText = CMDCLEARTIP_LOC

ADD OBJECT sepClr1   AS SEPARATOR

ADD OBJECT lbl5 	AS LABEL WITH ;
	Caption = LBL5CAP_LOC, ;
	WIDTH = 18, ;
	BackColor = RGB(192,192,192)

ADD OBJECT cboGDemo	AS combobox WITH ;
	VALUE = 1, ;
	STYLE = 2, ;
	WIDTH = 20, ;
	ToolTipText = CBOGDEMOTIP_LOC

ADD OBJECT sepCG1	AS SEPARATOR

ADD OBJECT cmdDone	AS commandbutton WITH ;
	HEIGHT = 1.75, ;
	WIDTH = 18, ;
	Caption = CMDDONECAP_LOC, ;
	ToolTipText = CMDDONETIP_LOC

PROCEDURE Init
	*- Setup and Dock ToolBar
	THIS.DockIt(1)
	THIS.ScaleMode = 3
	THIS.Caption = TBRCAP_LOC
	THIS.ControlBox = .F.
	THIS.SetAll('FontSize',8)
ENDPROC

PROCEDURE Destroy
	THIS.Visible = .F.
	THISFORMSET.frmFD.Visible = .F.
	WAIT WINDOW WUNLOAD_LOC NOWAIT NOCLEAR
	_SCREEN.BackColor = RGB(255,255,255)
	RELEASE frmFD, fdmain
	_SCREEN.ScaleMode = 0
	WAIT CLEAR
	cErrorSave = ON("ERROR")
	ON ERROR DO fdMainErr with ERROR()
	IF !(TYPE('Main') = "U" OR ISNULL('Main'))
		Main.Show
	ELSE
		IF WEXIST('main')
			ACTI WIND main
		ENDIF
	ENDIF
	ON ERROR &cErrorSave
	* Not working in B340
	* RELEASE PROCEDURE FdProc.prg
ENDPROC

PROCEDURE cmdDraw.Click
	THISFORMSET.frmFD.DrawAction (THISFORMSET.frmFD.MousePointer)
	IF THISFORMSET.frmFD.MousePointer = 1
		THIS.Caption = CMDDRAWCAP1_LOC
	ELSE
		THIS.Caption = CMDDRAWCAP2_LOC
	ENDIF
ENDPROC

PROCEDURE cmdDrawMode.Click
	THISFORMSET.frmFD.ChgDrawMode
	IF THISFORMSET.frmFD.nDrawMode = 1
		THIS.Caption = CMDDRAWMODECAP1_LOC
	ELSE
		THIS.Caption = CMDDRAWMODECAP2_LOC
	ENDIF
ENDPROC

PROCEDURE spnPenWidth.InteractiveChange
	THISFORMSET.frmFD.SetPenWidth ( THIS.value )
	THISFORMSET.frmFD.SetCaption
ENDPROC

PROCEDURE cboPenMode.InteractiveChange
	THISFORMSET.frmFD.SetDrawMode ( THIS.value )
ENDPROC

PROCEDURE cboGDemo.CLick
	THISFORMSET.frmFD.GraphDemo ( THIS.value )
ENDPROC

PROCEDURE cmdRed.CLICK
	THISFORMSET.frmFD.DrawColor ( RGB(255,0,0), THIS.caption )
ENDPROC

PROCEDURE cmdGreen.CLICK
	THISFORMSET.frmFD.DrawColor ( RGB(0,255,0), THIS.caption )
ENDPROC

PROCEDURE cmdBlue.CLICK
	THISFORMSET.frmFD.DrawColor ( RGB(0,0,255),THIS.caption )
ENDPROC

PROCEDURE cmdCustom.CLICK
	LOCAL lnColor
	lnColor = GETCOLOR()
	THISFORMSET.frmFD.DrawColor ( lnColor, THIS.caption )
	THIS.forecolor = lnColor
ENDPROC

PROCEDURE cmdErase.CLICK
	THISFORMSET.frmFD.DrawColor ( RGB(255,255,255), THIS.caption )
ENDPROC

PROCEDURE cmdClear.CLICK
	THISFORMSET.frmFD.ClearForm
ENDPROC

PROCEDURE cmdDone.Click
	RELEASE THISFORMSET
ENDPROC

PROCEDURE cmdDone.RightClick
	SUSPEND
ENDPROC

PROCEDURE cboPenMode.Init
	THIS.AddItem ( "1-Blackness",1)
	THIS.AddItem ( "2-Not Merge Pen",2 )
	THIS.AddItem ( "3-Mask Not Pen",3 )
	THIS.AddItem ( "4-Not Copy Pen",4 )
	THIS.AddItem ( "5-Mask Pen Not",5 )
	THIS.AddItem ( "6-Invert",6 )
	THIS.AddItem ( "7-Xor Pen",7 )
	THIS.AddItem ( "8-Not Mask Pen",8 )
	THIS.AddItem ( "9-Mask Pen",9 )
	THIS.AddItem ( "10-Not Xor Pen",10 )
	THIS.AddItem ( "11-Nop",11 )
	THIS.AddItem ( "12-Merge Not Pen",12 )
	THIS.AddItem ( "13-Copy Pen(Def)",13 )
	THIS.AddItem ( "14-Merge Pen Not",14 )
	THIS.AddItem ( "15-Merge Pen",15 )
	THIS.AddItem ( "16-Whiteness",16 )
ENDPROC

PROCEDURE cboGDemo.Init
	THIS.AddItem ( CBOGDEMOITEM1,1 )
	THIS.AddItem ( CBOGDEMOITEM2,2 )
	THIS.AddItem ( CBOGDEMOITEM3,3 )
	THIS.AddItem ( CBOGDEMOITEM4,4 )
	THIS.AddItem ( CBOGDEMOITEM5,5 )
	THIS.AddItem ( CBOGDEMOITEM6,6 )
	THIS.AddItem ( CBOGDEMOITEM7,7 )
	THIS.AddItem ( CBOGDEMOITEM8,8 )
ENDPROC

ENDDEFINE

PROCEDURE HideToolBar
*- Not used in this release (need toolbar names to stabilize).
	IF WVISIBLE ('layout')
		HIDE WINDOW layout
		m.llLayout = .T.
	ENDIF
	IF WVISIBLE ('form')
		HIDE WINDOW FORM
		m.llForm = .T.
	ENDIF
	IF WVISIBLE ( 'controls')
		HIDE WINDOW controls
		m.llControls = .T.
	ENDIF
	IF WVISIBLE ('palette')
		HIDE WINDOW palette
		m.llPalette = .T.
	ENDIF
ENDPROC

PROCEDURE ShowToolBar
	IF m.llControls
		ACTI WINDOW controls
		m.llControls = .F.
	ENDIF
	IF m.llForm
		SHOW WINDOW FORM
		m.llForm = .F.
	ENDIF
	IF m.llLayout
		SHOW WINDOW layout
		m.llLayout = .F.
	ENDIF
	IF m.llPalette
		SHOW WINDOW palette
		m.llPalette = .F.
	ENDIF

ENDPROC

PROCEDURE fdMainErr
	PARAMETERS nError
	IF nError = 1924
		RETURN
	ELSE
		WAIT WINDOW "Error:"+STR(nError)
	ENDIF
ENDPROC

** EOF FdProc.prg
